import { isExternalLink, normalizePathname } from '../links.js';
export default function (options) {
    const opts = {
        activeClassName: 'active-link',
        externalRel: 'noopener noreferrer',
        within: 'body',
        ...options
    };
    return {
        name: 'doxicity-link-plugin',
        transform: (doc, page) => {
            doc.querySelectorAll(opts.within).forEach(el => {
                el.querySelectorAll('a').forEach(link => {
                    if (isExternalLink(link)) {
                        if (opts.externalRel && !link.hasAttribute('rel')) {
                            link.setAttribute('rel', opts.externalRel);
                        }
                        return;
                    }
                    if (normalizePathname(link.pathname) === normalizePathname(page.pathname)) {
                        link.classList.add(opts.activeClassName);
                    }
                });
            });
            return doc;
        }
    };
}
