export default function (options) {
    const opts = {
        activeClassName: 'active-link',
        externalRel: 'noopener noreferrer',
        within: 'body',
        ...options
    };
    return {
        name: 'doxicity-link-plugin',
        transform: (doc, page) => {
            doc.querySelectorAll(opts.within).forEach(el => {
                el.querySelectorAll('a').forEach(link => {
                    if (isExternalLink(link)) {
                        if (opts.externalRel && !link.hasAttribute('rel')) {
                            link.setAttribute('rel', opts.externalRel);
                        }
                        return;
                    }
                    if (normalizePathname(link.pathname) === normalizePathname(page.pathname)) {
                        link.classList.add(opts.activeClassName);
                    }
                });
            });
            return doc;
        }
    };
}
function isExternalLink(link) {
    if (!link.hostname || link.hostname === 'internal')
        return false;
    return true;
}
function normalizePathname(pathname) {
    pathname = pathname.trim();
    if (!pathname.startsWith('/')) {
        pathname = `/${pathname}`;
    }
    if (pathname.endsWith('/index.html')) {
        pathname = pathname.slice(0, -10);
    }
    return pathname;
}
