export type FilterFunction = (filename: string) => boolean;
export interface DoxicityConfig {
    source: string;
    destination: string;
    layouts: string;
    partials: string;
    assets: string;
    data: {
        [key: string]: unknown;
    };
    cleanBeforePublishing: boolean;
    plugins: DoxicityPlugin[];
    helpers: DoxicityHelper[];
    filter: FilterFunction;
    extension: string;
}
export interface DoxicityHelper {
    name: string;
    callback: (args: unknown) => string;
}
export interface DoxicityPage {
    sourceFile: string;
    destinationFile: string;
    pathname: string;
    data: Record<string, unknown>;
}
export interface DoxicityPlugin {
    name: string;
    transform?: (doc: Document, page: DoxicityPage) => Document | Promise<Document>;
    afterTransform?: (html: string, page: DoxicityPage) => string | Promise<string>;
    afterAll?: (pages: DoxicityPage[]) => void | Promise<void>;
}
export interface DoxicityPublishResult {
    pages: DoxicityPage[];
    assets: string[];
    timeToPublish: number;
}
